# ObsFile

> Obs file source connector

### Key features[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#key-features) <a href="#key-features" id="key-features"></a>

* [x] &#x20;batch
* [ ] &#x20;stream
* [x] &#x20;exactly-once

Read all the data in a split in a pollNext call. What splits are read will be saved in snapshot.

* [x] &#x20;column projection
* [x] &#x20;parallelism
* [ ] &#x20;support user-defined split
* [x] &#x20;file format type
  * [x] &#x20;text
  * [x] &#x20;csv
  * [x] &#x20;parquet
  * [x] &#x20;orc
  * [x] &#x20;json
  * [x] &#x20;excel

### Description[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#description) <a href="#description" id="description"></a>

Read data from huawei cloud obs file system.

We made some trade-offs in order to support more file types, so we used the HDFS protocol for internal access to OBS and this connector need some hadoop dependencies. It only supports hadoop version **2.9.X+**.

### Options[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#options) <a href="#options" id="options"></a>

| name                         | type    | required | default             | description                                                                                                     |
| ---------------------------- | ------- | -------- | ------------------- | --------------------------------------------------------------------------------------------------------------- |
| path                         | string  | yes      | -                   | The target dir path                                                                                             |
| file\_format\_type           | string  | yes      | -                   | File type.                                                                                                      |
| bucket                       | string  | yes      | -                   | The bucket address of obs file system, for example: `obs://obs-bucket-name`                                     |
| access\_key                  | string  | yes      | -                   | The access key of obs file system                                                                               |
| access\_secret               | string  | yes      | -                   | The access secret of obs file system                                                                            |
| endpoint                     | string  | yes      | -                   | The endpoint of obs file system                                                                                 |
| read\_columns                | list    | yes      | -                   | The read column list of the data source, user can use it to implement field projection.                         |
| delimiter                    | string  | no       | \001                | Field delimiter, used to tell connector how to slice and dice fields when reading text files                    |
| parse\_partition\_from\_path | boolean | no       | true                | Control whether parse the partition keys and values from file path.                                             |
| skip\_header\_row\_number    | long    | no       | 0                   | Skip the first few lines, but only for the txt and csv.                                                         |
| date\_format                 | string  | no       | yyyy-MM-dd          | Date type format, used to tell the connector how to convert string to date.                                     |
| datetime\_format             | string  | no       | yyyy-MM-dd HH:mm:ss | Datetime type format, used to tell the connector how to convert string to datetime.                             |
| time\_format                 | string  | no       | HH:mm:ss            | Time type format, used to tell the connector how to convert string to time.                                     |
| schema                       | config  | no       | -                   |                                                                                                                 |
| common-options               |         | no       | -                   | [Source Common Options](/data-integration-with-nexus/nexus-elements/connectors/source/source-common-options.md) |
| sheet\_name                  | string  | no       | -                   | Reader the sheet of the workbook,Only used when file\_format is excel.                                          |

#### Tips[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#tips) <a href="#tips" id="tips"></a>

**parse\_partition\_from\_path** [**​**](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#-parse_partition_from_path-)

> Control whether parse the partition keys and values from file path
>
> For example if you read a file from path `obs://hadoop-cluster/tmp/nexus/parquet/name=tyrantlucifer/age=26`
>
> Every record data from the file will be added these two fields:

| name          | age |
| ------------- | --- |
| tyrantlucifer | 26  |

> Do not define partition fields in schema option

**date\_format** [**​**](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#-date_format-)

> Date type format, used to tell the connector how to convert string to date, supported as the following formats:
>
> `yyyy-MM-dd` `yyyy.MM.dd` `yyyy/MM/dd`
>
> default `yyyy-MM-dd`

#### datetime\_format [​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#-datetime_format-) <a href="#datetime_format" id="datetime_format"></a>

> Datetime type format, used to tell the connector how to convert string to datetime, supported as the following formats:
>
> `yyyy-MM-dd HH:mm:ss` `yyyy.MM.dd HH:mm:ss` `yyyy/MM/dd HH:mm:ss` `yyyyMMddHHmmss`
>
> default `yyyy-MM-dd HH:mm:ss`

#### time\_format [​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#-time_format-) <a href="#time_format" id="time_format"></a>

> Time type format, used to tell the connector how to convert string to time, supported as the following formats:
>
> `HH:mm:ss` `HH:mm:ss.SSS`
>
> default `HH:mm:ss`

#### skip\_header\_row\_number [​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#-skip_header_row_number-) <a href="#skip_header_row_number" id="skip_header_row_number"></a>

> Skip the first few lines, but only for the txt and csv.
>
> For example, set like following:
>
> `skip_header_row_number = 2`
>
> Then Nexus will skip the first 2 lines from source files

#### file\_format\_type [​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#-file_format_type-) <a href="#file_format_type" id="file_format_type"></a>

> File type, supported as the following file types:
>
> `text` `csv` `parquet` `orc` `json` `excel`
>
> If you assign file type to `json`, you should also assign schema option to tell the connector how to parse data to the row you want.
>
> For example,upstream data is the following:
>
> ```
> ```

{"code": 200, "data": "get success", "success": true}

````

> You can also save multiple pieces of data in one file and split them by one newline:

```json lines

{"code":  200, "data":  "get success", "success":  true}
{"code":  300, "data":  "get failed", "success":  false}

````

> you should assign schema as the following:

```

schema {
    fields {
        code = int
        data = string
        success = boolean
    }
}

```

> connector will generate data as the following:

| code | data        | success |
| ---- | ----------- | ------- |
| 200  | get success | true    |

> If you assign file type to `parquet` `orc`, schema option not required, connector can find the schema of upstream data automatically.
>
> If you assign file type to `text` `csv`, you can choose to specify the schema information or not.
>
> For example, upstream data is the following:

```

tyrantlucifer#26#male

```

> If you do not assign data schema connector will treat the upstream data as the following:

| content               |
| --------------------- |
| tyrantlucifer#26#male |

> If you assign data schema, you should also assign the option `delimiter` too except CSV file type
>
> you should assign schema and delimiter as the following:

```

delimiter = "#"
schema {
    fields {
        name = string
        age = int
        gender = string 
    }
}

```

> connector will generate data as the following:

| name          | age | gender |
| ------------- | --- | ------ |
| tyrantlucifer | 26  | male   |

**schema** [**​**](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#-schema--)

**fields**[**​**](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#fields)

> The schema of upstream data.

**read\_columns** [**​**](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#-read_columns-)

> The read column list of the data source, user can use it to implement field projection.
>
> The file type supported column projection as the following shown:

* text
* json
* csv
* orc
* parquet
* excel

> If the user wants to use this feature when reading `text` `json` `csv` files, the schema option must be configured

**common options** [**​**](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#-common-options-)

> Source plugin common parameters, please refer to [Source Common Options](/data-integration-with-nexus/nexus-elements/connectors/source/source-common-options.md) for details.

### Task Example[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#task-example) <a href="#task-example" id="task-example"></a>

#### text file[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#text-file) <a href="#text-file" id="text-file"></a>

> For text file format simple config

```

  ObsFile {
    path = "/nexus/text"
    bucket = "obs://obs-bucket-name"
    access_key = "xxxxxxxxxxxxxxxxx"
    access_secret = "xxxxxxxxxxxxxxxxxxxxxx"
    endpoint = "obs.xxxxxx.myhuaweicloud.com"
    file_format_type = "text"
  }

```

#### parquet file[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#parquet-file) <a href="#parquet-file" id="parquet-file"></a>

> For parquet file format simple config

```

  ObsFile {
    path = "/nexus/parquet"
    bucket = "obs://obs-bucket-name"
    access_key = "xxxxxxxxxxxxxxxxx"
    access_secret = "xxxxxxxxxxxxxxxxxxxxxx"
    endpoint = "obs.xxxxxx.myhuaweicloud.com"
    file_format_type = "parquet"
  }

```

#### orc file[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#orc-file) <a href="#orc-file" id="orc-file"></a>

> For orc file format simple config

```

  ObsFile {
    path = "/nexus/orc"
    bucket = "obs://obs-bucket-name"
    access_key = "xxxxxxxxxxxxxxxxx"
    access_secret = "xxxxxxxxxxxxxxxxxxxxxx"
    endpoint = "obs.xxxxxx.myhuaweicloud.com"
    file_format_type = "orc"
  }

```

#### json file[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#json-file) <a href="#json-file" id="json-file"></a>

> For json file format simple config

```

  ObsFile {
    path = "/nexus/json"
    bucket = "obs://obs-bucket-name"
    access_key = "xxxxxxxxxxxxxxxxx"
    access_secret = "xxxxxxxxxxxxxxxxxxxxxx"
    endpoint = "obs.xxxxxx.myhuaweicloud.com"
    file_format_type = "json"
  }

```

#### excel file[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#excel-file) <a href="#excel-file" id="excel-file"></a>

> For excel file format simple config

```

  ObsFile {
    path = "/nexus/excel"
    bucket = "obs://obs-bucket-name"
    access_key = "xxxxxxxxxxxxxxxxx"
    access_secret = "xxxxxxxxxxxxxxxxxxxxxx"
    endpoint = "obs.xxxxxx.myhuaweicloud.com"
    file_format_type = "excel"
  }

```

#### csv file[​](https://seatunnel.apache.org/docs/2.3.7/connector-v2/source/ObsFile#csv-file) <a href="#csv-file" id="csv-file"></a>

> For csv file format simple config

```

  ObsFile {
    path = "/nexus/csv"
    bucket = "obs://obs-bucket-name"
    access_key = "xxxxxxxxxxxxxxxxx"
    access_secret = "xxxxxxxxxxxxxxxxxxxxxx"
    endpoint = "obs.xxxxxx.myhuaweicloud.com"
    file_format_type = "csv"
    delimiter = ","
  }
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.selfuel.digital/data-integration-with-nexus/nexus-elements/connectors/source/obsfile.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
